Index: /palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- /palm/trunk/SOURCE/salsa_mod.f90	(revision 3863)
+++ /palm/trunk/SOURCE/salsa_mod.f90	(revision 3864)
@@ -5543,179 +5601,155 @@
 !> Called from subroutine condensation. 
 !> Coded by:
-!> Harri Kokkola (FMI) 
+!> Harri Kokkola (FMI)
 !------------------------------------------------------------------------------! 
- SUBROUTINE gpparthno3( ppres, ptemp, paero, pghno3, pgnh3, pcw, pcs, pbeta,   &
-                        ptstep )
-               
+ SUBROUTINE gpparthno3( ppres, ptemp, paero, pghno3, pgnh3, pcw, pcs, pbeta, ptstep )
+
     IMPLICIT NONE
-!
-!-- Input and output variables 
-    REAL(wp), INTENT(in) ::  pbeta(nbins) !< transitional correction factor for
-                                          !< aerosols    
-    REAL(wp), INTENT(in) ::  ppres        !< ambient pressure (Pa) 
-    REAL(wp), INTENT(in) ::  pcs          !< water vapour saturation 
-                                          !< concentration (kg/m3)
-    REAL(wp), INTENT(in) ::  ptemp        !< ambient temperature (K)
-    REAL(wp), INTENT(in) ::  ptstep       !< time step (s)
-    REAL(wp), INTENT(inout) ::  pghno3    !< nitric acid concentration (#/m3)
-    REAL(wp), INTENT(inout) ::  pgnh3     !< ammonia conc. (#/m3)    
-    REAL(wp), INTENT(inout) ::  pcw       !< water vapour concentration (kg/m3)
-    TYPE(t_section), INTENT(inout) ::  paero(nbins) !< Aerosol properties
-!    
-!-- Local variables
-    INTEGER(iwp) ::  b              !< loop index
-    REAL(wp) ::  adt                !< timestep 
-    REAL(wp) ::  zachhso4ae(nbins)  !< Activity coefficients for HHSO4
-    REAL(wp) ::  zacnh3ae(nbins)    !< Activity coefficients for NH3
-    REAL(wp) ::  zacnh4hso2ae(nbins)!< Activity coefficients for NH4HSO2
-    REAL(wp) ::  zacno3ae(nbins)    !< Activity coefficients for HNO3
-    REAL(wp) ::  zcgnh3eqae(nbins)  !< Equilibrium gas concentration: NH3
-    REAL(wp) ::  zcgno3eqae(nbins)  !< Equilibrium gas concentration: HNO3
-    REAL(wp) ::  zcnh3c             !< Current NH3 gas concentration
-    REAL(wp) ::  zcnh3int           !< Intermediate NH3 gas concentration
-    REAL(wp) ::  zcnh3intae(nbins)  !< Intermediate NH3 aerosol concentration
-    REAL(wp) ::  zcnh3n             !< New NH3 gas concentration
-    REAL(wp) ::  zcnh3cae(nbins)    !< Current NH3 in aerosols
-    REAL(wp) ::  zcnh3nae(nbins)    !< New NH3 in aerosols 
-    REAL(wp) ::  zcnh3tot           !< Total NH3 concentration
-    REAL(wp) ::  zcno3c             !< Current HNO3 gas concentration
-    REAL(wp) ::  zcno3int           !< Intermediate HNO3 gas concentration
-    REAL(wp) ::  zcno3intae(nbins)  !< Intermediate HNO3 aerosol concentration
-    REAL(wp) ::  zcno3n             !< New HNO3 gas concentration                 
-    REAL(wp) ::  zcno3cae(nbins)    !< Current HNO3 in aerosols
-    REAL(wp) ::  zcno3nae(nbins)    !< New HNO3 in aerosols
-    REAL(wp) ::  zcno3tot           !< Total HNO3 concentration   
-    REAL(wp) ::  zdfvap             !< Diffusion coefficient for vapors
-    REAL(wp) ::  zhlp1              !< helping variable
-    REAL(wp) ::  zhlp2              !< helping variable    
-    REAL(wp) ::  zkelnh3ae(nbins)   !< Kelvin effects for NH3
-    REAL(wp) ::  zkelno3ae(nbins)   !< Kelvin effect for HNO3
-    REAL(wp) ::  zmolsae(nbins,7)   !< Ion molalities from pdfite
-    REAL(wp) ::  zmtnh3ae(nbins)    !< Mass transfer coefficients for NH3
-    REAL(wp) ::  zmtno3ae(nbins)    !< Mass transfer coefficients for HNO3
-    REAL(wp) ::  zrh                !< relative humidity
-    REAL(wp) ::  zsathno3ae(nbins)  !< HNO3 saturation ratio
-    REAL(wp) ::  zsatnh3ae(nbins)   !< NH3 saturation ratio = the partial 
-                                    !< pressure of a gas divided by its 
-                                    !< saturation vapor pressure over a surface
-!          
+
+    INTEGER(iwp) ::  ib  !< loop index
+
+    REAL(wp) ::  adt          !< timestep
+    REAL(wp) ::  zc_nh3_c     !< Current NH3 gas concentration
+    REAL(wp) ::  zc_nh3_int   !< Intermediate NH3 gas concentration
+    REAL(wp) ::  zc_nh3_n     !< New NH3 gas concentration
+    REAL(wp) ::  zc_nh3_tot   !< Total NH3 concentration
+    REAL(wp) ::  zc_hno3_c    !< Current HNO3 gas concentration
+    REAL(wp) ::  zc_hno3_int  !< Intermediate HNO3 gas concentration
+    REAL(wp) ::  zc_hno3_n    !< New HNO3 gas concentration
+    REAL(wp) ::  zc_hno3_tot  !< Total HNO3 concentration
+    REAL(wp) ::  zdfvap       !< Diffusion coefficient for vapors
+    REAL(wp) ::  zhlp1        !< intermediate variable
+    REAL(wp) ::  zhlp2        !< intermediate variable
+    REAL(wp) ::  zrh          !< relative humidity
+
+    REAL(wp), INTENT(in) ::  ppres      !< ambient pressure (Pa)
+    REAL(wp), INTENT(in) ::  pcs        !< water vapour saturation
+                                        !< concentration (kg/m3)
+    REAL(wp), INTENT(in) ::  ptemp      !< ambient temperature (K)
+    REAL(wp), INTENT(in) ::  ptstep     !< time step (s)
+
+    REAL(wp), INTENT(inout) ::  pghno3  !< nitric acid concentration (#/m3)
+    REAL(wp), INTENT(inout) ::  pgnh3   !< ammonia conc. (#/m3)
+    REAL(wp), INTENT(inout) ::  pcw     !< water vapour concentration (kg/m3)
+
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zac_hno3_ae     !< Activity coefficients for HNO3
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zac_hhso4_ae    !< Activity coefficients for HHSO4
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zac_nh3_ae      !< Activity coefficients for NH3
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zac_nh4hso2_ae  !< Activity coefficients for NH4HSO2
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zcg_hno3_eq_ae  !< Equilibrium gas concentration: HNO3
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zcg_nh3_eq_ae   !< Equilibrium gas concentration: NH3
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zc_hno3_int_ae  !< Intermediate HNO3 aerosol concentration
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zc_hno3_c_ae    !< Current HNO3 in aerosols
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zc_hno3_n_ae    !< New HNO3 in aerosols
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zc_nh3_int_ae   !< Intermediate NH3 aerosol concentration
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zc_nh3_c_ae     !< Current NH3 in aerosols
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zc_nh3_n_ae     !< New NH3 in aerosols
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zkel_hno3_ae    !< Kelvin effect for HNO3
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zkel_nh3_ae     !< Kelvin effects for NH3
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zmt_hno3_ae     !< Mass transfer coefficients for HNO3
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zmt_nh3_ae      !< Mass transfer coefficients for NH3
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zsat_hno3_ae    !< HNO3 saturation ratio over a surface
+    REAL(wp), DIMENSION(nbins_aerosol) ::  zsat_nh3_ae     !< NH3 saturation ratio over a surface
+
+    REAL(wp), DIMENSION(nbins_aerosol,maxspec) ::  zion_mols   !< Ion molalities from pdfite aerosols
+
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(in) ::  pbeta !< transitional correction factor for
+
+    TYPE(t_section), DIMENSION(nbins_aerosol), INTENT(inout) ::  paero !< Aerosol properties
+!
 !-- Initialise:
-    adt          = ptstep
-    zachhso4ae   = 0.0_wp
-    zacnh3ae     = 0.0_wp
-    zacnh4hso2ae = 0.0_wp
-    zacno3ae     = 0.0_wp
-    zcgnh3eqae   = 0.0_wp
-    zcgno3eqae   = 0.0_wp
-    zcnh3c       = 0.0_wp
-    zcnh3cae     = 0.0_wp
-    zcnh3int     = 0.0_wp
-    zcnh3intae   = 0.0_wp
-    zcnh3n       = 0.0_wp
-    zcnh3nae     = 0.0_wp
-    zcnh3tot     = 0.0_wp
-    zcno3c       = 0.0_wp
-    zcno3cae     = 0.0_wp  
-    zcno3int     = 0.0_wp
-    zcno3intae   = 0.0_wp
-    zcno3n       = 0.0_wp
-    zcno3nae     = 0.0_wp
-    zcno3tot     = 0.0_wp
-    zhlp1        = 0.0_wp
-    zhlp2        = 0.0_wp
-    zkelno3ae    = 1.0_wp   
-    zkelnh3ae    = 1.0_wp  
-    zmolsae      = 0.0_wp
-    zmtno3ae     = 0.0_wp
-    zmtnh3ae     = 0.0_wp
-    zrh          = 0.0_wp
-    zsatnh3ae    = 1.0_wp
-    zsathno3ae   = 1.0_wp
-!             
-!-- Diffusion coefficient (m2/s)             
-    zdfvap = 5.1111E-10_wp * ptemp ** 1.75_wp * ( p_0 + 1325.0_wp ) / ppres 
-!             
+    adt            = ptstep
+    zac_hhso4_ae   = 0.0_wp
+    zac_nh3_ae     = 0.0_wp
+    zac_nh4hso2_ae = 0.0_wp
+    zac_hno3_ae    = 0.0_wp
+    zcg_nh3_eq_ae  = 0.0_wp
+    zcg_hno3_eq_ae = 0.0_wp
+    zion_mols      = 0.0_wp
+    zsat_nh3_ae    = 1.0_wp
+    zsat_hno3_ae   = 1.0_wp
+!
+!-- Diffusion coefficient (m2/s)
+    zdfvap = 5.1111E-10_wp * ptemp**1.75_wp * ( p_0 + 1325.0_wp ) / ppres
+!
 !-- Kelvin effects (Jacobson (2005), eq. 16.33)
-    zkelno3ae(1:nbins) = EXP( 4.0_wp * surfw0 * amvhno3 / ( abo * ptemp *      &
-                              paero(1:nbins)%dwet ) ) 
-    zkelnh3ae(1:nbins) = EXP( 4.0_wp * surfw0 * amvnh3 / ( abo * ptemp *       &
-                              paero(1:nbins)%dwet ) )
-!                             
+    zkel_hno3_ae(1:nbins_aerosol) = EXP( 4.0_wp * surfw0 * amvhno3 /                               &
+                                    ( abo * ptemp * paero(1:nbins_aerosol)%dwet ) )
+    zkel_nh3_ae(1:nbins_aerosol) = EXP( 4.0_wp * surfw0 * amvnh3 /                                 &
+                                   ( abo * ptemp * paero(1:nbins_aerosol)%dwet ) )
+!
 !-- Current vapour mole concentrations (mol/m3)
-    zcno3c = pghno3 / avo            ! HNO3
-    zcnh3c = pgnh3 / avo             ! NH3
-!             
+    zc_hno3_c = pghno3 / avo  ! HNO3
+    zc_nh3_c = pgnh3 / avo   ! NH3
+!
 !-- Current particle mole concentrations (mol/m3)
-    zcno3cae(1:nbins) = paero(1:nbins)%volc(6) * arhohno3 / amhno3
-    zcnh3cae(1:nbins) = paero(1:nbins)%volc(7) * arhonh3 / amnh3
-!    
+    zc_hno3_c_ae(1:nbins_aerosol) = paero(1:nbins_aerosol)%volc(6) * arhohno3 / amhno3
+    zc_nh3_c_ae(1:nbins_aerosol) = paero(1:nbins_aerosol)%volc(7) * arhonh3 / amnh3
+!
 !-- Total mole concentrations: gas and particle phase
-    zcno3tot = zcno3c + SUM( zcno3cae(1:nbins) )
-    zcnh3tot = zcnh3c + SUM( zcnh3cae(1:nbins) )
-!   
+    zc_hno3_tot = zc_hno3_c + SUM( zc_hno3_c_ae(1:nbins_aerosol) )
+    zc_nh3_tot = zc_nh3_c + SUM( zc_nh3_c_ae(1:nbins_aerosol) )
+!
 !-- Relative humidity [0-1]
     zrh = pcw / pcs
-!    
+!
 !-- Mass transfer coefficients (Jacobson, Eq. 16.64)
-    zmtno3ae(1:nbins) = 2.0_wp * pi * paero(1:nbins)%dwet * zdfvap *           &
-                        paero(1:nbins)%numc * pbeta(1:nbins)
-    zmtnh3ae(1:nbins) = 2.0_wp * pi * paero(1:nbins)%dwet * zdfvap *           &
-                        paero(1:nbins)%numc * pbeta(1:nbins)
-
-!    
+    zmt_hno3_ae(:) = 2.0_wp * pi * paero(:)%dwet * zdfvap * paero(:)%numc * pbeta(:)
+    zmt_nh3_ae(:)  = 2.0_wp * pi * paero(:)%dwet * zdfvap * paero(:)%numc * pbeta(:)
+
+!
 !-- Get the equilibrium concentrations above aerosols
-    CALL NONHEquil( zrh, ptemp, paero, zcgno3eqae, zcgnh3eqae, zacno3ae,       &
-                    zacnh3ae, zacnh4hso2ae, zachhso4ae, zmolsae )
-    
-!
-!-- NH4/HNO3 saturation ratios for aerosols
-    CALL SVsat( ptemp, paero, zacno3ae, zacnh4hso2ae, zachhso4ae, zcgno3eqae,  &
-                zcno3cae, zcnh3cae, zkelno3ae, zkelnh3ae, zsathno3ae, zsatnh3ae )
-!    
-!-- Intermediate concentrations    
-    zhlp1 = SUM( zcno3cae(1:nbins) / ( 1.0_wp + adt * zmtno3ae(1:nbins) *      &
-            zsathno3ae(1:nbins) ) )
-    zhlp2 = SUM( zmtno3ae(1:nbins) / ( 1.0_wp + adt * zmtno3ae(1:nbins) *      &
-            zsathno3ae(1:nbins) ) )
-    zcno3int = ( zcno3tot - zhlp1 ) / ( 1.0_wp + adt * zhlp2 )
-
-    zhlp1 = SUM( zcnh3cae(1:nbins) / ( 1.0_wp + adt * zmtnh3ae(1:nbins) *      &
-            zsatnh3ae(1:nbins) ) )
-    zhlp2 = SUM( zmtnh3ae(1:nbins) / ( 1.0_wp + adt * zmtnh3ae(1:nbins) *      &
-            zsatnh3ae(1:nbins) ) )
-    zcnh3int = ( zcnh3tot - zhlp1 )/( 1.0_wp + adt * zhlp2 )
-
-    zcno3int = MIN(zcno3int, zcno3tot)
-    zcnh3int = MIN(zcnh3int, zcnh3tot)
-!
-!-- Calculate the new particle concentrations
-    zcno3intae = zcno3cae
-    zcnh3intae = zcnh3cae
-    DO  b = 1, nbins
-       zcno3intae(b) = ( zcno3cae(b) + adt * zmtno3ae(b) * zcno3int ) /     &
-            ( 1.0_wp + adt * zmtno3ae(b) * zsathno3ae(b) )
-       zcnh3intae(b) = ( zcnh3cae(b) + adt * zmtnh3ae(b) * zcnh3int ) /     &
-            ( 1.0_wp + adt * zmtnh3ae(b) * zsatnh3ae(b) )
+    CALL nitrate_ammonium_equilibrium( zrh, ptemp, paero, zcg_hno3_eq_ae, zcg_nh3_eq_ae,           &
+                                       zac_hno3_ae, zac_nh3_ae, zac_nh4hso2_ae, zac_hhso4_ae,      &
+                                       zion_mols )
+!
+!-- Calculate NH3 and HNO3 saturation ratios for aerosols
+    CALL nitrate_ammonium_saturation( ptemp, paero, zac_hno3_ae, zac_nh4hso2_ae, zac_hhso4_ae,     &
+                                      zcg_hno3_eq_ae, zc_hno3_c_ae, zc_nh3_c_ae, zkel_hno3_ae,     &
+                                      zkel_nh3_ae, zsat_hno3_ae, zsat_nh3_ae )
+!
+!-- Intermediate gas concentrations of HNO3 and NH3
+    zhlp1 = SUM( zc_hno3_c_ae(:) / ( 1.0_wp + adt * zmt_hno3_ae(:) * zsat_hno3_ae(:) ) )
+    zhlp2 = SUM( zmt_hno3_ae(:) / ( 1.0_wp + adt * zmt_hno3_ae(:) * zsat_hno3_ae(:) ) )
+    zc_hno3_int = ( zc_hno3_tot - zhlp1 ) / ( 1.0_wp + adt * zhlp2 )
+
+    zhlp1 = SUM( zc_nh3_c_ae(:) / ( 1.0_wp + adt * zmt_nh3_ae(:) * zsat_nh3_ae(:) ) )
+    zhlp2 = SUM( zmt_nh3_ae(:) / ( 1.0_wp + adt * zmt_nh3_ae(:) * zsat_nh3_ae(:) ) )
+    zc_nh3_int = ( zc_nh3_tot - zhlp1 )/( 1.0_wp + adt * zhlp2 )
+
+    zc_hno3_int = MIN( zc_hno3_int, zc_hno3_tot )
+    zc_nh3_int = MIN( zc_nh3_int, zc_nh3_tot )
+!
+!-- Calculate the new concentration on aerosol particles
+    zc_hno3_int_ae = zc_hno3_c_ae
+    zc_nh3_int_ae = zc_nh3_c_ae
+    DO  ib = 1, nbins_aerosol
+       zc_hno3_int_ae(ib) = ( zc_hno3_c_ae(ib) + adt * zmt_hno3_ae(ib) * zc_hno3_int ) /           &
+                            ( 1.0_wp + adt * zmt_hno3_ae(ib) * zsat_hno3_ae(ib) )
+       zc_nh3_int_ae(ib) = ( zc_nh3_c_ae(ib) + adt * zmt_nh3_ae(ib) * zc_nh3_int ) /               &
+                           ( 1.0_wp + adt * zmt_nh3_ae(ib) * zsat_nh3_ae(ib) )
     ENDDO
 
-    zcno3intae(1:nbins) = MAX( zcno3intae(1:nbins), 0.0_wp )
-    zcnh3intae(1:nbins) = MAX( zcnh3intae(1:nbins), 0.0_wp )
-
-    zcno3n   = zcno3int    ! Final molar gas concentration of HNO3
-    zcno3nae = zcno3intae  ! Final molar particle concentration of HNO3
-    
-    zcnh3n   = zcnh3int    ! Final molar gas concentration of NH3
-    zcnh3nae = zcnh3intae  ! Final molar particle concentration of NH3
-!
-!-- Model timestep reached - update the new arrays
-    pghno3 = zcno3n * avo
-    pgnh3  = zcnh3n * avo
-
-    DO  b = in1a, fn2b
-       paero(b)%volc(6) = zcno3nae(b) * amhno3 / arhohno3
-       paero(b)%volc(7) = zcnh3nae(b) * amnh3 / arhonh3
+    zc_hno3_int_ae(:) = MAX( zc_hno3_int_ae(:), 0.0_wp )
+    zc_nh3_int_ae(:) = MAX( zc_nh3_int_ae(:), 0.0_wp )
+!
+!-- Final molar gas concentration and molar particle concentration of HNO3
+    zc_hno3_n   = zc_hno3_int
+    zc_hno3_n_ae = zc_hno3_int_ae
+!
+!-- Final molar gas concentration and molar particle concentration of NH3
+    zc_nh3_n   = zc_nh3_int
+    zc_nh3_n_ae = zc_nh3_int_ae
+!
+!-- Model timestep reached - update the gas concentrations
+    pghno3 = zc_hno3_n * avo
+    pgnh3  = zc_nh3_n * avo
+!
+!-- Update the particle concentrations
+    DO  ib = start_subrange_1a, end_subrange_2b
+       paero(ib)%volc(6) = zc_hno3_n_ae(ib) * amhno3 / arhohno3
+       paero(ib)%volc(7) = zc_nh3_n_ae(ib) * amnh3 / arhonh3
     ENDDO
-    
-   
+
  END SUBROUTINE gpparthno3
 !------------------------------------------------------------------------------!
@@ -5724,82 +5758,80 @@
 !> Calculate the equilibrium concentrations above aerosols (reference?)
 !------------------------------------------------------------------------------!
- SUBROUTINE NONHEquil( prh, ptemp, ppart, pcgno3eq, pcgnh3eq, pgammano,        &
-                       pgammanh, pgammanh4hso2, pgammahhso4, pmols )
-    
+ SUBROUTINE nitrate_ammonium_equilibrium( prh, ptemp, ppart, pcg_hno3_eq, pcg_nh3_eq, pgamma_hno3, &
+                                          pgamma_nh4, pgamma_nh4hso2, pgamma_hhso4, pmols )
+
     IMPLICIT NONE
-    
+
+    INTEGER(iwp) ::  ib  !< loop index: aerosol bins
+
+    REAL(wp) ::  zhlp         !< intermediate variable
+    REAL(wp) ::  zp_hcl       !< Equilibrium vapor pressures (Pa) of HCl
+    REAL(wp) ::  zp_hno3      !< Equilibrium vapor pressures (Pa) of HNO3
+    REAL(wp) ::  zp_nh3       !< Equilibrium vapor pressures (Pa) of NH3
+    REAL(wp) ::  zwatertotal  !< Total water in particles (mol/m3)
+
     REAL(wp), INTENT(in) ::  prh    !< relative humidity
     REAL(wp), INTENT(in) ::  ptemp  !< ambient temperature (K)
-    
-    TYPE(t_section), INTENT(inout) ::  ppart(nbins) !< Aerosol properties
-!-- Equilibrium molar concentration above aerosols:
-    REAL(wp), INTENT(inout) ::  pcgnh3eq(nbins)      !< of NH3 
-    REAL(wp), INTENT(inout) ::  pcgno3eq(nbins)      !< of HNO3 
-                                                     !< Activity coefficients:
-    REAL(wp), INTENT(inout) ::  pgammahhso4(nbins)   !< HHSO4   
-    REAL(wp), INTENT(inout) ::  pgammanh(nbins)      !< NH3
-    REAL(wp), INTENT(inout) ::  pgammanh4hso2(nbins) !< NH4HSO2  
-    REAL(wp), INTENT(inout) ::  pgammano(nbins)      !< HNO3
-    REAL(wp), INTENT(inout) ::  pmols(nbins,7)       !< Ion molalities
-    
-    INTEGER(iwp) ::  b
-
-    REAL(wp) ::  zgammas(7)    !< Activity coefficients    
-    REAL(wp) ::  zhlp          !< Dummy variable
-    REAL(wp) ::  zions(7)      !< molar concentration of ion (mol/m3)
-    REAL(wp) ::  zphcl         !< Equilibrium vapor pressures (Pa??)    
-    REAL(wp) ::  zphno3        !< Equilibrium vapor pressures (Pa??)
-    REAL(wp) ::  zpnh3         !< Equilibrium vapor pressures (Pa??)
-    REAL(wp) ::  zwatertotal   !< Total water in particles (mol/m3) ???    
+
+    REAL(wp), DIMENSION(maxspec) ::  zgammas  !< Activity coefficients
+    REAL(wp), DIMENSION(maxspec) ::  zions    !< molar concentration of ion (mol/m3)
+
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(inout) ::  pcg_nh3_eq      !< equilibrium molar
+                                                                          !< concentration: of NH3
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(inout) ::  pcg_hno3_eq     !< of HNO3
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(inout) ::  pgamma_hhso4    !< activity coeff. of HHSO4
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(inout) ::  pgamma_nh4      !< activity coeff. of NH3
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(inout) ::  pgamma_nh4hso2  !< activity coeff. of NH4HSO2
+    REAL(wp), DIMENSION(nbins_aerosol), INTENT(inout) ::  pgamma_hno3     !< activity coeff. of HNO3
+
+    REAL(wp), DIMENSION(nbins_aerosol,maxspec), INTENT(inout) ::  pmols  !< Ion molalities
+
+    TYPE(t_section), DIMENSION(nbins_aerosol), INTENT(inout) ::  ppart  !< Aerosol properties
 
     zgammas     = 0.0_wp
     zhlp        = 0.0_wp
     zions       = 0.0_wp
-    zphcl       = 0.0_wp
-    zphno3      = 0.0_wp
-    zpnh3       = 0.0_wp
+    zp_hcl      = 0.0_wp
+    zp_hno3     = 0.0_wp
+    zp_nh3      = 0.0_wp
     zwatertotal = 0.0_wp
 
-    DO  b = 1, nbins
-    
-       IF ( ppart(b)%numc < nclim )  CYCLE
-!
-!--    2*H2SO4 + CL + NO3 - Na - NH4
-       zhlp = 2.0_wp * ppart(b)%volc(1) * arhoh2so4 / amh2so4 +               &
-              ppart(b)%volc(5) * arhoss / amss +                              &
-              ppart(b)%volc(6) * arhohno3 / amhno3 -                          &
-              ppart(b)%volc(5) * arhoss / amss -                              &
-              ppart(b)%volc(7) * arhonh3 / amnh3
-
-       zhlp = MAX( zhlp, 1.0E-30_wp )
+    DO  ib = 1, nbins_aerosol
+
+       IF ( ppart(ib)%numc < nclim )  CYCLE
+!
+!--    Ion molar concentrations: 2*H2SO4 + CL + NO3 - Na - NH4
+       zhlp = 2.0_wp * ppart(ib)%volc(1) * arhoh2so4 / amh2so4 + ppart(ib)%volc(5) * arhoss / amss &
+              + ppart(ib)%volc(6) * arhohno3 / amhno3 - ppart(ib)%volc(5) * arhoss / amss -        &
+              ppart(ib)%volc(7) * arhonh3 / amnh3
 
        zions(1) = zhlp                                   ! H+
-       zions(2) = ppart(b)%volc(7) * arhonh3 / amnh3     ! NH4+
-       zions(3) = ppart(b)%volc(5) * arhoss / amss       ! Na+
-       zions(4) = ppart(b)%volc(1) * arhoh2so4 / amh2so4 ! SO4(2-)
+       zions(2) = ppart(ib)%volc(7) * arhonh3 / amnh3     ! NH4+
+       zions(3) = ppart(ib)%volc(5) * arhoss / amss       ! Na+
+       zions(4) = ppart(ib)%volc(1) * arhoh2so4 / amh2so4 ! SO4(2-)
        zions(5) = 0.0_wp                                 ! HSO4-
-       zions(6) = ppart(b)%volc(6) * arhohno3 / amhno3   ! NO3-
-       zions(7) = ppart(b)%volc(5) * arhoss / amss       ! Cl-
-
-       zwatertotal = ppart(b)%volc(8) * arhoh2o / amh2o
+       zions(6) = ppart(ib)%volc(6) * arhohno3 / amhno3   ! NO3-
+       zions(7) = ppart(ib)%volc(5) * arhoss / amss       ! Cl-
+
+       zwatertotal = ppart(ib)%volc(8) * arhoh2o / amh2o
        IF ( zwatertotal > 1.0E-30_wp )  THEN
-          CALL inorganic_pdfite( prh, ptemp, zions, zwatertotal, zphno3, zphcl,&
-                                 zpnh3, zgammas, pmols(b,:) )
-       ENDIF
-!
-!--    Activity coefficients 
-       pgammano(b) = zgammas(1)           ! HNO3
-       pgammanh(b) = zgammas(3)           ! NH3 
-       pgammanh4hso2(b) = zgammas(6)      ! NH4HSO2
-       pgammahhso4(b) = zgammas(7)        ! HHSO4
+          CALL inorganic_pdfite( prh, ptemp, zions, zwatertotal, zp_hno3, zp_hcl, zp_nh3, zgammas, &
+                                 pmols(ib,:) )
+       ENDIF
+!
+!--    Activity coefficients
+       pgamma_hno3(ib)    = zgammas(1)  ! HNO3
+       pgamma_nh4(ib)     = zgammas(3)  ! NH3
+       pgamma_nh4hso2(ib) = zgammas(6)  ! NH4HSO2
+       pgamma_hhso4(ib)   = zgammas(7)  ! HHSO4
 !
 !--    Equilibrium molar concentrations (mol/m3) from equlibrium pressures (Pa)
-       pcgno3eq(b) = zphno3 / ( argas * ptemp )
-       pcgnh3eq(b) = zpnh3 / ( argas * ptemp )
+       pcg_hno3_eq(ib) = zp_hno3 / ( argas * ptemp )
+       pcg_nh3_eq(ib) = zp_nh3 / ( argas * ptemp )
 
     ENDDO
 
-  END SUBROUTINE NONHEquil
-  
+  END SUBROUTINE nitrate_ammonium_equilibrium
+
 !------------------------------------------------------------------------------!
 ! Description:
